import { ofType } from 'redux-observable';
import { concat, EMPTY, of, timer } from 'rxjs';
import { debounce, switchMap } from 'rxjs/operators';

import { GET_XRAY_LINE_ITEM_DOMAIN_OPTIONS } from '@/graphql/services/xRayLineItems/constants';

import { PAYLOAD_NAME } from '@/graphql/services/xRayLineItems/types/payload/domain';

import { hubSelector } from '../selectors';
import { getDomainOptionsAction, setAction } from '../slices';
import { gqlRequest } from '@/modules/@common/request';

const query = `
  query ${GET_XRAY_LINE_ITEM_DOMAIN_OPTIONS}($payload: ${PAYLOAD_NAME}) {
    ${GET_XRAY_LINE_ITEM_DOMAIN_OPTIONS}(payload: $payload) {
      records {
        id
        domain
     }   
    }
  }
`;

const getResponse = ({ data }) =>
  data[GET_XRAY_LINE_ITEM_DOMAIN_OPTIONS].records.map((o) => ({ label: o.domain, value: o.id }));

export default (action$, state$) =>
  action$.pipe(
    ofType(getDomainOptionsAction.type),
    debounce((action) => {
      const search = action.payload;
      return timer(search?.length > 1 ? 1000 : 0);
    }),
    switchMap((action) => {
      const publisherId = hubSelector(state$.value)?.id;

      if (!publisherId) {
        return EMPTY;
      }

      const stream$ = gqlRequest({
        query,
        variables: {
          payload: {
            searchText: action.payload ?? '',
            pageSize: 30,
            publisherId,
          },
        },
      }).pipe(
        switchMap((response) => {
          if (!response.errors.length) {
            return of(
              setAction({
                domainOptions: getResponse(response),
              }),
            );
          }

          return EMPTY;
        }),
      );

      return concat(stream$);
    }),
  );
